var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import { AstroJSX, isVNode } from "../../jsx-runtime/index.js";
import {
  escapeHTML,
  Fragment,
  HTMLString,
  markHTMLString,
  renderComponent,
  spreadAttributes,
  voidElementNames
} from "./index.js";
async function renderJSX(result, vnode) {
  switch (true) {
    case vnode instanceof HTMLString:
      return vnode;
    case typeof vnode === "string":
      return markHTMLString(escapeHTML(vnode));
    case (!vnode && vnode !== 0):
      return "";
    case vnode.type === Fragment:
      return renderJSX(result, vnode.props.children);
    case Array.isArray(vnode):
      return markHTMLString((await Promise.all(vnode.map((v) => renderJSX(result, v)))).join(""));
  }
  if (vnode[AstroJSX]) {
    if (!vnode.type && vnode.type !== 0)
      return "";
    if (typeof vnode.type === "string") {
      return await renderElement(result, vnode.type, vnode.props ?? {});
    }
    if (!!vnode.type) {
      let extractSlots = function(child) {
        if (Array.isArray(child)) {
          return child.map((c) => extractSlots(c));
        }
        if (!isVNode(child)) {
          return slots.default.push(child);
        }
        if ("slot" in child.props) {
          slots[child.props.slot] = [...slots[child.props.slot] ?? [], child];
          delete child.props.slot;
          return;
        }
        slots.default.push(child);
      };
      try {
        const output = await vnode.type(vnode.props ?? {});
        if (output && output[AstroJSX]) {
          return await renderJSX(result, output);
        } else if (!output) {
          return await renderJSX(result, output);
        }
      } catch (e) {
      }
      const _a = vnode.props ?? {}, { children = null } = _a, props = __objRest(_a, ["children"]);
      const slots = {
        default: []
      };
      extractSlots(children);
      for (const [key, value] of Object.entries(slots)) {
        slots[key] = () => renderJSX(result, value);
      }
      return markHTMLString(await renderComponent(result, vnode.type.name, vnode.type, props, slots));
    }
  }
  return markHTMLString(`${vnode}`);
}
async function renderElement(result, tag, _a) {
  var _b = _a, { children } = _b, props = __objRest(_b, ["children"]);
  return markHTMLString(`<${tag}${spreadAttributes(props)}${markHTMLString((children == null || children == "") && voidElementNames.test(tag) ? `/>` : `>${children == null ? "" : await renderJSX(result, children)}</${tag}>`)}`);
}
export {
  renderJSX
};
